local function getNewAddon(name, versionVar, version)
	local addon = _G[name]
	if addon then
		if addon[versionVar] and addon[versionVar] >= version then
print("skipping", name, versionVar, version, addon[versionVar])
			return nil
		else
print("upgrading", name, versionVar, version, addon[versionVar])
			addon[versionVar] = version
			return addon
		end
	else
print("creating", name, versionVar, version)
		local addon = { }
		addon[versionVar] = version
		_G[name] = addon
		return addon
	end
end

local u = getNewAddon("BittensUtilities", "Version", 1)
if u == nil then
	return
end

local select = select

function u.GetNewAddon(name, versionName, version)
	return getNewAddon(name, versionName, version)
end

function u.GetFromTable(outerTable, ...)
	for i = 1, select("#", ...) do
		local key = select(i, ...)
		outerTable = outerTable[key]
		if outerTable == nil then
			return nil
		end
	end
	return outerTable
end

function u.GetOrMakeTable(outerTable, ...)
	for i = 1, select("#", ...) do
		local key = select(i, ...)
		if outerTable[key] == nil then
			outerTable[key] = {}
		end
		outerTable = outerTable[key]
	end
	return outerTable
end
